[submodule] Add docker-salt-formulas, ci/build.sh 95/61195/2
authorAlexandru Avadanii <Alexandru.Avadanii@enea.com>
Sun, 19 Aug 2018 15:52:02 +0000 (17:52 +0200)
committerAlexandru Avadanii <Alexandru.Avadanii@enea.com>
Tue, 21 Aug 2018 15:52:34 +0000 (17:52 +0200)
- add new git submodule pointing to upstream docker build scripts;
- add patch extending Docker tags with an '-(arch)' suffix,
  aligning with OPNFV tagging requiremnts;
- add <ci/build.sh> wrapper for starting Docker builds;
- install build-specific distro package requirements, as well as
  pip-managed packages (e.g. pipenv);

JIRA: FUEL-383

Change-Id: Id4fc886206d7eaf7e6d02810380f2391609ba405
Signed-off-by: Alexandru Avadanii <Alexandru.Avadanii@enea.com>
.gitmodules
ci/build.sh [new file with mode: 0755]
docker [new submodule]
mcp/patches/docker/0001-OPNFV-tag-convention-alignment.patch [new file with mode: 0644]

index c7c4458..d3501c3 100644 (file)
@@ -10,3 +10,7 @@
        path = mcp/scripts/pharos
        url = https://github.com/opnfv/pharos
        branch = master
+[submodule "docker"]
+       path = docker
+       url = https://github.com/epcim/docker-salt-formulas
+       branch = master
diff --git a/ci/build.sh b/ci/build.sh
new file mode 100755 (executable)
index 0000000..9bca187
--- /dev/null
@@ -0,0 +1,79 @@
+#!/bin/bash -e
+# shellcheck disable=SC1004,SC1090
+##############################################################################
+# Copyright (c) 2018 Mirantis Inc., Enea AB and others.
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
+
+##############################################################################
+# BEGIN of Exit handlers
+#
+do_exit () {
+    local RC=$?
+    if [ ${RC} -eq 0 ]; then
+        notify_n "[OK] MCP: Docker build finished succesfully!" 2
+    else
+        notify_n "[ERROR] MCP: Docker build threw a fatal error!"
+    fi
+}
+#
+# End of Exit handlers
+##############################################################################
+
+##############################################################################
+# BEGIN of variables to customize
+#
+CI_DEBUG=${CI_DEBUG:-0}; [[ "${CI_DEBUG}" =~ (false|0) ]] || set -x
+MCP_REPO_ROOT_PATH=$(readlink -f "$(dirname "${BASH_SOURCE[0]}")/..")
+DEPLOY_DIR=$(cd "${MCP_REPO_ROOT_PATH}/mcp/scripts"; pwd)
+DOCKER_DIR=$(cd "${MCP_REPO_ROOT_PATH}/docker"; pwd)
+DOCKER_TAG=${1:-latest}
+
+source "${DEPLOY_DIR}/globals.sh"
+source "${DEPLOY_DIR}/lib.sh"
+
+#
+# END of variables to customize
+##############################################################################
+
+##############################################################################
+# BEGIN of main
+#
+
+# Enable the automatic exit trap
+trap do_exit SIGINT SIGTERM EXIT
+
+# Set no restrictive umask so that Jenkins can remove any residuals
+umask 0000
+
+# Clone git submodules and apply our patches
+make -C "${MCP_REPO_ROOT_PATH}/mcp/patches" deepclean patches-import
+
+pushd "${DOCKER_DIR}" > /dev/null
+
+# Install distro packages and pip-managed prerequisites
+notify "[NOTE] Installing required build-time distro and pip pkgs" 2
+jumpserver_pkg_install 'build'
+pip install pipenv --user
+docker_install
+
+pipenv --two
+pipenv install
+pipenv shell \
+  "invoke build saltmaster-reclass \
+    --require 'salt salt-formulas reclass tini-saltmaster' \
+    --dist=ubuntu \
+    --dist-rel=xenial \
+    --formula-rev=nightly \
+    --opnfv-tag='${DOCKER_TAG}' \
+    --salt='stable 2017.7'; \
+  exit"
+
+popd > /dev/null
+
+#
+# END of main
+##############################################################################
diff --git a/docker b/docker
new file mode 160000 (submodule)
index 0000000..d580f1e
--- /dev/null
+++ b/docker
@@ -0,0 +1 @@
+Subproject commit d580f1ef272a29268a1825e7f810979ade6b2b71
diff --git a/mcp/patches/docker/0001-OPNFV-tag-convention-alignment.patch b/mcp/patches/docker/0001-OPNFV-tag-convention-alignment.patch
new file mode 100644 (file)
index 0000000..aa0b01c
--- /dev/null
@@ -0,0 +1,78 @@
+::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
+: Copyright (c) 2018 Mirantis Inc., Enea AB and others.
+:
+: All rights reserved. This program and the accompanying materials
+: are made available under the terms of the Apache License, Version 2.0
+: which accompanies this distribution, and is available at
+: http://www.apache.org/licenses/LICENSE-2.0
+::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
+From: Alexandru Avadanii <Alexandru.Avadanii@enea.com>
+Date: Tue, 21 Aug 2018 02:42:35 +0200
+Subject: [PATCH] OPNFV tag convention alignment
+
+* (arch)- prefix Docker tags
+  Hacky implementation that only detects 'arm64', otherwise it will
+  default to 'amd64'.
+  Note that Docker arch notation uses 'arm64' instead of 'aarch64'.
+* Override Docker tag to align with OPNFV format
+* use Docker repository: opnfv/fuel
+
+Signed-off-by: Alexandru Avadanii <Alexandru.Avadanii@enea.com>
+---
+ invoke.yml | 2 +-
+ tasks.py   | 7 +++++--
+ 2 files changed, 6 insertions(+), 3 deletions(-)
+
+diff --git a/invoke.yml b/invoke.yml
+index 0bd793e..291f4c7 100644
+--- a/invoke.yml
++++ b/invoke.yml
+@@ -65,7 +65,7 @@ target:
+
+ dockermake:
+   destination: 'images'
+-  repository:  'docker.io/epcim/salt'
++  repository:  'docker.io/opnfv/fuel'
+   # options: '--no-cache'
+   # options: '--bust-cache reclass'
+   # options: '--registry-user epcim'
+diff --git a/tasks.py b/tasks.py
+index d6bf3bc..092c6e7 100644
+--- a/tasks.py
++++ b/tasks.py
+@@ -6,6 +6,7 @@ from invoke import Collection, task
+ from string import Template
+ import re
+ import ast
++import platform
+
+ # TODOs:
+ # - WIP - use namespace to expose images/targets as inoke tasks # image = Collection('image')
+@@ -25,8 +26,9 @@ def all(ctx, dry=False, push=False, dry_targets=False, filter=None, **kwargs):
+                      dry=dry, push=push, dry_targets=dry_targets, filter=filter, **kwargs)
+
+ @task
+-def build(ctx, target, require=[], dist='debian', dist_rel='stretch', salt=None, formula_rev=None, push=False, dry=False, dry_targets=False, **kwargs):
++def build(ctx, target, require=[], dist='debian', dist_rel='stretch', salt=None, formula_rev=None, opnfv_tag='latest', push=False, dry=False, dry_targets=False, **kwargs):
+
++    kwargs['arch'] = 'arm64' if platform.machine() == 'aarch64' else 'amd64'
+     kwargs['dist'] = dist
+     kwargs['dist_rel'] = dist_rel
+     kwargs['dry'] = True if dry_targets or dry else False
+@@ -35,6 +37,7 @@ def build(ctx, target, require=[], dist='debian', dist_rel='stretch', salt=None,
+     kwargs['require'] = require
+     kwargs['salt'] = salt
+     kwargs['target'] = target
++    kwargs['opnfv_tag'] = opnfv_tag
+     # command formating + update
+     fmt = {'tag': ''}
+     fmt.update(ctx.dockermake)
+@@ -56,7 +59,7 @@ def build(ctx, target, require=[], dist='debian', dist_rel='stretch', salt=None,
+     # execute
+     cmd = Template("""
+             ${dry}docker-make -f DockerMake.${dist}.yml -u ${repository}: --name ${target} \
+-            \t-t ${dist}-${dist_rel}${tag} \
++            \t-t ${arch}-${opnfv_tag} \
+             \t--requires ${requires} \
+             \t--build-arg SALT_VERSION="${salt}" \
+             \t--build-arg SALT_FORMULA_VERSION="${formula_rev}" \